/*** VARIABILI GLOBALI ***/
var audio_enable;		// Contiene informazioni sullo stato dell audio (on = abilitato; off = disabilitato)
var timer_enable;		// Contiene informazioni sullo stato del timer (on = abilitato; off = disabilitato)
var timer_duration;		// Contiene informazioni sulla durata del timer (in secondi)
var language;			// Contiene informazioni sulla lingua

var timer;					// Timer
var current_timer_enable;	// Contiene informazioni circa l impostazione corrente dell abilitazione del timer

var first_time_start_app; 	//per capire se e la prima volta che si avvia l app

var backPage;				// Contiene informazioni circa la pagina a cui ritornare da impostazioni o info

var music;					// Contiene riferimento per la musica iniziale
var plic;					// Contiene riferimento suono per click nelle varie aree
var currentAnimal;			// Contiene informazioni sull animale visualizzato

var mrobotVoice;
var musica_sottofondo;
var animalVoice;
var mv, msv, av;		// Variabili utilizzate per gestire il cancella setTimeout

var urlAdvices = "http://www.appsandgamesforkids.com"; // URL per Consigli
var urlFullVersion = 'market://details?id=com.wemotic.woodanimalsoundcards';

//VARIABILI VERSIONE FREE X BANNER ADS
var numeroBanner;
var idBannerADS;
/******************************************************************************/
/*** PLAYER AUDIO ***/
//PER LA 1.0 DI PHONE GAP
function createMedia (url)
{
	return new Media(url, onSuccess, onError);
}

// onSuccess Callback
function onSuccess() {
	//console.log("Create Media Audio: Success");
}

// onError Callback
function onError(error) {
 //alert(error.code    + ' ' + error.message);
}

/*** FINE PLAYER AUDIO PER LA 1.0 DI PHONEGAP ***/
// Esegue la riproduzione del file audio
function playAudio(media)
{
	media.play();
}

// Ferma la riproduzione del file audio
function stopAudio(media)
{
	media.stop();
}

// Mette in pause la riproduzione del file audio
function pauseAudio(media)
{
	media.pause();
}

// Fa il resume della riproduzione audio di un file messo in pause
function resumeAudio(media)
{
	media.play();
}

// Rilascia le risorse audio
function releaseAudio(media)
{
	media.release();
}

/******************************************************************************/

/*** TIMER ***/

function eduTimer()
{
	// Verifica sempre se il timer e abilitato
	if(timer_enable == 'on')
	{
		if(timer == 0)
		{
			var tests = 3;
			var	code;

			do
			{
				switch(language)
				{
					case 'it':
									code = prompt(" Tempo scaduto.\n Inserire 1234 per continuare.\n Inserire 0000 per uscire");
									break;
					case 'en':
									code = prompt(" Out of time.\n Insert 1234 to continue.\n Insert 0000 to exit");
									break;
					case 'es':
									code = prompt(" Entrar en 1234 para continuar.\n Entrar 0000 para salir");
									break;
					default:
						code = prompt(" Out of time.\n Insert 1234 to continue.\n Insert 0000 to exit");
				}

				switch(code)
				{

					case '1234':
									// Se il codice di sblocco e corretto reimposta il timer
									timer = timer_duration;
									setTimeout("eduTimer()",1000);
									return;

					case '0000':
									// Chidue l applicazione
									device.exitApp();
									return;
									break;

					default:
									// Consente di riprovare ad inserire il codice di sblocco
									tests = tests - 1;
									break;
				}
			}
			while(tests != 0);

			// Chiude l applicazione		
			device.exitApp();
		}
		else
		{
			timer = timer - 1;
			setTimeout("eduTimer()",1000);
		}

	}

	return;
}


// Avvia il timer
function startTimer()
{
	// Avvia il timer solo se abilitato
	if(timer_enable == 'on')
	{
		eduTimer();
	}
}

/******************************************************************************/

/*** INZIALIZZAZIONE APPLICAZIONE ***/

function clickEducappy(iconApp)
{
	
	// Riproduce suono "plic" associato al "click"
	playAudio(plic);
	// Ferma la riproduzione della musica nella pagina principale
	// e rilascia le varie risorse allocate
	stopAudio(music);
	releaseAudio(music);
	
	// Setta link in funzione dell app associata all icona cliccata
	switch(iconApp)
	{
		case 'educappy': 
						if(language == 'it'){
							var urlEducappy = 'http://www.appsandgamesforkids.com/'+language+'/educappy';
						}
						else{
							var urlEducappy = 'http://www.appsandgamesforkids.com/en/educappy';
						}						
						break;

		case 'comingsoon':    //punto al sito x i coming soon
						if(language == 'it'){
							urlEducappy = 'http://www.appsandgamesforkids.com/'+language+'/coming-soon';
						}
						else{
							urlEducappy = 'http://www.appsandgamesforkids.com/en/coming-soon';
						}
						break;
		case 'downloads':
						if(language == 'it'){
							urlEducappy = 'http://www.appsandgamesforkids.com/it/download';
						}
						else{
							urlEducappy = 'http://www.appsandgamesforkids.com/en/download';
						}
						break;
		case 'facebook':
						// Carica url pagina facebook
						urlEducappy = "http://www.facebook.com/pages/Educational-Apps-for-kids/122876677795353";
						break;
		case 'twitter':
						// Carica url pagina facebook
						urlEducappy = "http://twitter.com/#!/Wemotic";
						break;
						
	}	
	// Apre link
	window.open(urlEducappy);
}

function clickStart()
{
	// Riproduce suono "plic" associato al "click"
	playAudio(plic);

	// Ferma la riproduzione della musica nella pagina principale
	// e rilascia le varie risorse allocate	
	stopAudio(music);
	releaseAudio(music);
	if(localStorage.getItem('first_time_start_app') == "1")
	{
		backPage = 'index.html';
		var path = 'pages/languagesettingsPage.html';
		$("#wrapper").load(path);
	}
	else{
		var path = 'pages/halloweenPage.html';
		$("#wrapper").load(path);
	}

	// Avvia il timer (in realta il timer sara avviato solo se abilitato)
	startTimer();

	return false;
}

// Gestisce click "Coming Soon"
function clickComingSoon()
{
	var urlComingSoon;

	// Riproduce suono "plic" associato al "click"
	playAudio(plic);

	// Ferma la riproduzione della musica nella pagina principale
	// e rilascia le varie risorse allocate
	stopAudio(music);
	releaseAudio(music);	
	urlComingSoon = 'market://search?q=pub:wemotic';	
	// Apre link
	window.open(urlComingSoon);

}

// Carica impostazioni applicazioni
function loadSettings()
{
	//per capire se  e la pria volta che viene avviata l app
	if(localStorage.getItem('first_time_start_app') == '' || localStorage.getItem('first_time_start_app') == null)
	{
		// Imposta status first_time_start_app al valore di default 1: TRUE
		first_time_start_app = "1";
		localStorage.setItem('first_time_start_app',"1");
	}
	else
	{
		// Imposta status first_time_start_app al valore memorizzato
		//verra messo a 0 dopo che avra scelto per la prima volta la linga con cui intende fruire l app
		first_time_start_app = localStorage.getItem('first_time_start_app');
	}

	// Carica impostazioni relative all'audio
	if(localStorage.getItem('animalsAudio') == '' || localStorage.getItem('animalsAudio') == null)
	{
		// Imposta status audio al valore di default 'abilitato'
		audio_enable = "on";
		localStorage.setItem('animalsAudio',"on");
	}
	else
	{
		// Imposta status audio al valore scelto dall'utente
		audio_enable = localStorage.getItem('animalsAudio');
	}


	// Carica impostazioni relative al timer
	if(localStorage.getItem('animalsTimer') == '' || localStorage.getItem('animalsTimer') == null)
	{
		// Imposta status timer al valore di default disabilitato
		timer_enable = "off";
		localStorage.setItem('animalsTimer',"off");
	}
	else
	{
		// Imposta status timer al valore scelto dall utente
		timer_enable = localStorage.getItem('animalsTimer');
	}


	// Carica impostazioni relative alla durata del timer
	if(localStorage.getItem('animalsDuration') == '' || localStorage.getItem('animalsDuration') == null)
	{
		// Imposta status timer al valore di default  29minuti = 1200 sec 
		timer_duration = 1200;
		localStorage.setItem('animalsDuration', 1200);
	}
	else
	{
		// Imposta status timer al valore scelto dall utente
		timer_duration = localStorage.getItem('animalsDuration');
	}


	// Carica impostazioni relativ alla lingua
	if(localStorage.getItem('animalsLanguage') == '' || localStorage.getItem('animalsLanguage') == null)
	{
		// Imposta la lingua al valore di default en
		language = 'en';
		localStorage.setItem('animalsLanguage','en');
	}
	else
	{
		// Imposta la linuga al valore scelto dall utente
		language = localStorage.getItem('animalsLanguage');
	}


	// Inizializza il timer pari a timer_duration
	timer = timer_duration;
	current_timer_enable = timer_enable;

}


// Naconde logo iniziale e carica la pagina start
function loadStartPage()
{
	$("#startMap").show('fast');
	$("#logo").hide('fast');
}


// Inizializza l applicazione
function init()
{
	// Carica impostazioni applicazione (Timer, Durata Timer, Lingua)
	loadSettings();

	// Inizializza suono di "plic" associato ai click nelle varie aree
	plic = createMedia("/android_asset/www/media/plic.mp3");

	// Richiama la funzione che nasconde il logo iniziale e carica la pagina start
	// settando il ritardo a 2 sec
	setTimeout("loadStartPage()",1000);
}

// Funzione richiamata quando phonegap e stato caricato e pronto per l uso
function onDeviceReady()
{
	// Inizializza i vari componenti dell applicazione
	init();
	// Inizializza musica all inizio dell applicazione
	music = createMedia("/android_asset/www/media/start.mp3");
	playAudio(music);
	return;
}

// Funzione associata al "onLoad" della pagina index.html dell applicazione
function start()
{
// Aggiunge listener per il corretto funzionamento di phonegap
document.addEventListener("deviceready",onDeviceReady,false);
}


/******************************************************************************/
/*** BANNER ***/
function showMarket(app){
// Apre link alla versione a pagamento
	if(app =='farm'){
		window.open('market://details?id=com.wemotic.farmanimals');
	}
	if(app =='wood'){
		window.open('market://details?id=com.wemotic.woodanimals');
	}
	if(app =='wood_cards'){
		window.open('market://details?id=com.wemotic.woodanimalsoundcards');
	}
	return false;
}

function hideBannersADS(){
//nascondo i banner
	$("#BANNER0").fadeOut(1500);
	$("#BANNER1").fadeOut(1500);
	$("#BANNER2").fadeOut(1500);	
}
function showADS()
{
	hideBannersADS();
	// Setta iol numero di casi possibili per la generazione del numero casuale - in base al numero dei banner
	//0. download farm
	//1. download wood
	numeroBanner = 3;

	// Genera un numero intero casuale tra 0 e 1
	idBannerADS = Math.floor(Math.random()*numeroBanner);
	// Carica banner corrispondente al numero casuale generato
	//mostro il DIV con il banner
	$("#BANNER"+idBannerADS+"").fadeIn(2000);
	return;
}
/******************************************************************************/

/*** ABOUT US ***/

function viewAboutUs()
{
	var urlAboutUs;

	switch(language)
	{
		case 'it':
						urlAboutUs = "http://www.appsandgamesforkids.com/it/contatti";
						break;

		default:
						urlAboutUs = "http://www.appsandgamesforkids.com/en/contact-us";		
	}

	window.open(urlAboutUs);

	return;

}

/******************************************************************************/

/*** PAGINA WOOD ***/


// Gestisce click sulle varie aree della mappa nella pagina WOOD
function clickAreaHalloween(area)
{
	// Riproduce suono "plic" associato al "click"
	playAudio(plic);	
	// Se l audio e abilitato rimuove il setTimeout, interrompe la riproduzione e rilascia le risorse
	if(audio_enable == 'on')
	{		
		// Ferma la riproduzione del file audio di sottofond		
		pauseAudio(musica_sottofondo);		
	}

	// Determina ed esegue operazioni associate all area selezionata
	switch(area)
	{
		case 'aboutus':
							viewAboutUs();
							break;

		case 'settings':
							// Carica pagina impostazioni
							backPage = 'pages/halloweenPage.html';
							var path = 'pages/settingsPage.html';
							$('#wrapper').load(path);
							break;
		case 'languagesettings':
							// Carica pagina impostazioni
							backPage = 'pages/halloweenPage.html';							
							var path = 'pages/languagesettingsPage.html';
							$('#wrapper').load(path);
							break;		
		case 'exit':	
					if(audio_enable == 'on')
					{
						// Cancella tutti i setTimeout		
						clearTimeout(msv);

						// Ferma la riproduzione del file audio di sottofond		
						stopAudio(musica_sottofondo);

						// Rilascia le risorse allocate		
						releaseAudio(musica_sottofondo);
					}
					// Chiude l applicazione
					device.exitApp();
					break;
		default:						
							//nascondo i BANNER ADS
							hideBannersADS();
							
							// Carica pagina singolo animale selezionato
							currentAnimal = area;							
							var path = 'pages/'+language+'/animals/'+area+'Page.html';
							$('#card').load(path); //nel DIV card carico la pagina
							$('#card').fadeIn(500);
							$('#backgroundopaco').fadeIn(500);
							//ritardo e chiudo il div
							setTimeout(function() {
								
								$('#backgroundopaco').hide();
								$('#card').fadeOut(500); //nascondo la card
								showADS(); //refresh del banner ADS
								resumeAudio(musica_sottofondo); //faccio ripartire la musica di sottofondo
								
							}, 10000); // time in milliseconds								
							break;
	}

	return false;
}

/******************************************************************************/
